#ifndef BASIC_H
#define BASIC_H 1
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <iostream>
#include <map>
#include <list>
#include <vector>
#include <string>
using namespace std;
struct _domain {
  virtual ~_domain(){}
};
struct Expr_domain : _domain {};
typedef Expr_domain *Expr;
struct Statement_domain : _domain {};
typedef Statement_domain *Statement;
struct op2 : Expr_domain {
	char op;
	Expr x,y;
	op2(char op, Expr x, Expr y):op(op), x(x), y(y){}
	~op2() { delete x; delete y; }
};
struct ident: Expr_domain {
	int v;
	ident(int v):v(v){}
};
struct number: Expr_domain {
	int x;
	number(int x):x(x){}
};
struct assign: Statement_domain {
	int v;
	Expr e;
	assign(int v, Expr e):v(v), e(e){}
	~assign() { delete e; }
};
struct ifstmt : Statement_domain {
	Expr e;
	list<Statement>* p1;
	list<Statement>* p2;
	ifstmt(Expr e, list<Statement>* p1, list<Statement>* p2):e(e), p1(p1), p2(p2){}
	~ifstmt() {
	  delete e;
	  for(auto s:*p1) delete s;
	  for(auto s:*p2) delete s;
	  delete p1;
	  delete p2;
	}
};
struct input: Statement_domain {
	int v;
	input(int v):v(v){}
};
struct print: Statement_domain {
	Expr e;
	print(Expr e):e(e){}
	~print() { delete e; }
};
struct printstr : Statement_domain {
	int c;
	printstr(int c):c(c){}
};
struct whilestmt : Statement_domain {
	Expr e;
	list<Statement> *p1;
	whilestmt(Expr e, list<Statement> *p1):e(e), p1(p1){}
	~whilestmt() {
	  delete e;
	  for(auto s:*p1) delete s;
	  delete p1;
	}
};
struct emptystmt : Statement_domain {};
void yystart(FILE *);
int yylex();
void yyerror(const char*);
void interpret(list<Statement> *);
int find_id(string name);
extern vector<string> tc;
#include "y.tab.h"
#endif
